local AddonName,T = ... --in jede Datei
local L = T["local"]	--in jede Datei, die die Lokalisierung braucht
local D = T["data"]		--in jede Datei, die die Daten braucht

local WHUT_DEBUG = {}
--[===[@debug@
WHUT_DEBUG["Listen"]=false --enables the debug-output for online/server/user-list
WHUT_DEBUG["Chat"]=true --enables the debug-output for Chatmessages and communication
WHUT_DEBUG["Roster"]=true --enables the debug-output for Raid/Guild-Updates
WHUT_DEBUG["GUI"]=false --enables the debug-output for GUI
WHUT_DEBUG["Data"]=false --enables the debug-output for Data-Management
--@end-debug@]===]

--Strings used for Data-Storing
local WHUT_VERSION = 0 
--@non-debug@
WHUT_VERSION = 15
--@end-non-debug@
local WHUT_ONLINE = "online"
local WHUT_SERVER = "server"
local WHUT_USER = "user"
local WHUT_QUEST = "quest"
local WHUT_FONT = "Fonts\\FRIZQT__.TTF"
local WHUT_FONTSIZE = 11
local WHUT_FONTFLAG = "OUTLINE, MONOCHROME"

--Data-Storing
WHUT_save = {} --must be global to be saved
WHUT_collapsed = {} --must be global to be available in templates.xml
--WHUT_frameX --must be global to be available in templates.xml
--WHUT_frameY --must be global to be available in templates.xml
local WHUT_user = {}
WHUT_user[WHUT_ONLINE] = {}
WHUT_user[WHUT_SERVER] = {}
WHUT_user[WHUT_USER] = {}
local WHUT_data = {}
WHUT_data[WHUT_QUEST] = {}
local Q = {}
local SHOW = {}
SHOW["active"] = true
SHOW["notactive"] = true
SHOW["unknown"] = true
SHOW["done"] = true
SHOW["notdone"] = true

--local Variables
local numberOfServers = 4
local actAsServer = false
local playerName = UnitName("player");
local playerFaction = UnitFactionGroup("player")
playerFaction = strsub(playerFaction,1,1)
local raidUpdate = 0
local serverUpdate = 0
local onlineSince = 0
local timeSinceLastUpdate = 0
local timeSinceLastSync = 0
local init = false
local WHUT_UpdateInterval = 1.0; -- How often the OnUpdate code will run (in seconds)
local WHUT_SyncInterval = 60;
local filterOffline = {}
local newVersionHint = false

--[===[@debug@
numberOfServers = 1
--@end-debug@]===]

-------------------------------------------------------------------------
---------------------------Frames&Events@load---------------------------
-------------------------------------------------------------------------

RegisterAddonMessagePrefix("WHUT")

local frame = CreateFrame("Frame","WHUT_frame",UIParent)
frame:RegisterEvent("CHAT_MSG_ADDON")
frame:RegisterEvent("GROUP_ROSTER_UPDATE")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("PLAYER_LEAVING_WORLD")
frame:RegisterEvent("PLAYER_TARGET_CHANGED")
frame:RegisterEvent("VARIABLES_LOADED")
frame:RegisterEvent("QUEST_ACCEPTED")
frame:RegisterEvent("QUEST_DETAIL")
frame:RegisterEvent("GOSSIP_SHOW")
frame:SetSize(100,50)
frame:SetFrameStrata("BACKGROUND")
frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }});
frame:SetBackdropColor(0,0,0,0.5)
frame:SetPoint("TOPLEFT",UIParent,"CENTER")
frame:SetMovable(true)
frame:SetUserPlaced(true)
frame:EnableMouse(true)
frame:RegisterForDrag("LeftButton")
frame:SetScript("OnDragStart", frame.StartMoving)
frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
frame:Show()

	--"menu"-frame
	frame.buttonFrame = CreateFrame("Frame",nil,frame)
	frame.buttonFrame:SetPoint("TOPLEFT",frame,"TOPLEFT")
		--Options
		frame.buttonFrame.optionsButton = CreateFrame("Button",nil,frame.buttonFrame,"GameMenuButtonTemplate")
		frame.buttonFrame.optionsButton:SetPoint("TOPLEFT",frame.buttonFrame,"TOPLEFT",5,-5)
		frame.buttonFrame.optionsButton:SetText(L["Options"])
		frame.buttonFrame.optionsButton:SetWidth(frame.buttonFrame.optionsButton:GetTextWidth()+10)
		frame.buttonFrame.optionsButton:SetScript("OnClick", function(self, button)
												WHUT_frame:ReAnchor()
												frame.optionsFrame:SetShown(not frame.optionsFrame:IsShown())
												WHUT_UpdateGui()
												end)
		--Clients
		frame.buttonFrame.clientsButton = CreateFrame("Button",nil,frame.buttonFrame,"GameMenuButtonTemplate")
		frame.buttonFrame.clientsButton:SetPoint("TOPLEFT",frame.buttonFrame.optionsButton,"TOPRIGHT",0,0)
		frame.buttonFrame.clientsButton:SetText(L["Clients"])
		frame.buttonFrame.clientsButton:SetWidth(frame.buttonFrame.optionsButton:GetTextWidth()+10)
		frame.buttonFrame.clientsButton:SetScript("OnClick", function(self, button)
												WHUT_frame:ReAnchor()
												frame.clients:SetShown(not frame.clients:IsShown())
												WHUT_UpdateGui()
												end)
		--Quests
		frame.buttonFrame.questsButton = CreateFrame("Button",nil,frame.buttonFrame,"GameMenuButtonTemplate")
		frame.buttonFrame.questsButton:SetPoint("TOPLEFT",frame.buttonFrame.clientsButton,"TOPRIGHT",0,0)
		frame.buttonFrame.questsButton:SetText(L["Quests"])
		frame.buttonFrame.questsButton:SetWidth(frame.buttonFrame.optionsButton:GetTextWidth()+10)
		frame.buttonFrame.questsButton:SetScript("OnClick", function(self, button)
												WHUT_frame:ReAnchor()
												frame.data:SetShown(not frame.data:IsShown())
												WHUT_UpdateGui()
												end)
	frame.buttonFrame:SetHeight(frame.buttonFrame.optionsButton:GetHeight())
	frame.buttonFrame:SetWidth(frame.buttonFrame.optionsButton:GetWidth()
								+frame.buttonFrame.clientsButton:GetWidth()
								+frame.buttonFrame.questsButton:GetWidth())
	frame.buttonFrame:Show()

	frame.optionsFrame = CreateFrame("Frame",nil,frame)
		--available
		CreateFrame("CheckButton","WHUT_CheckAvailable",frame.optionsFrame,"ChatConfigCheckButtonTemplate")
		WHUT_CheckAvailableText:SetText(L["available"])
		WHUT_CheckAvailableText:SetTextColor(0,1,0)
		WHUT_CheckAvailable:SetHitRectInsets(0,-WHUT_CheckAvailableText:GetWidth(),0,0)
		WHUT_CheckAvailable:SetPoint("TOPLEFT", frame.optionsFrame,"TOPLEFT")
		WHUT_CheckAvailable:SetScript("OnClick", function(self, button)
												WHUT_frame:ReAnchor()
												SHOW["active"]=self:GetChecked()
												WHUT_UpdateGui()
												end)
		--not available
		CreateFrame("CheckButton","WHUT_CheckNotAvailable",frame.optionsFrame,"ChatConfigCheckButtonTemplate")
		WHUT_CheckNotAvailableText:SetText(L["not available"])
		WHUT_CheckNotAvailableText:SetTextColor(1,0,0)
		WHUT_CheckNotAvailable:SetHitRectInsets(0,-WHUT_CheckNotAvailableText:GetWidth(),0,0)
		WHUT_CheckNotAvailable:SetPoint("TOPLEFT", WHUT_CheckAvailable ,"BOTTOMLEFT")
		WHUT_CheckNotAvailable:SetScript("OnClick", function(self, button)
												WHUT_frame:ReAnchor()
												SHOW["notactive"]=self:GetChecked()
												WHUT_UpdateGui()
												end)
		--unknown
		CreateFrame("CheckButton","WHUT_CheckUnknown",frame.optionsFrame,"ChatConfigCheckButtonTemplate")
		WHUT_CheckUnknownText:SetText(L["unknown"])
		WHUT_CheckUnknownText:SetTextColor(1,1,1)
		WHUT_CheckUnknown:SetHitRectInsets(0,-WHUT_CheckUnknownText:GetWidth(),0,0)
		WHUT_CheckUnknown:SetPoint("TOPLEFT", WHUT_CheckNotAvailable ,"BOTTOMLEFT")
		WHUT_CheckUnknown:SetScript("OnClick", function(self, button)
												WHUT_frame:ReAnchor()
												SHOW["unknown"]=self:GetChecked()
												WHUT_UpdateGui()
												end)
	frame.optionsFrame:SetHeight(WHUT_CheckAvailable:GetHeight()
								+WHUT_CheckNotAvailable:GetHeight()
								+WHUT_CheckUnknown:GetHeight())
	frame.optionsFrame:SetWidth(WHUT_CheckAvailable:GetWidth()
								+math.max(WHUT_CheckAvailableText:GetWidth(),
										WHUT_CheckNotAvailableText:GetWidth(),
										WHUT_CheckUnknownText:GetWidth()))
	frame.optionsFrame:Show()

	--clientlist
	frame.clients = CreateFrame("Frame",nil,frame)
	--[===[@debug@
	frame.clients:Show()
	--@end-debug@]===]
	--@non-debug@
	frame.clients:Hide()
	--@end-non-debug@
	frame.clients.names = {}
	frame.clients.fonts = {}

	--questlist
	frame.data = CreateFrame("Frame", "WHUT_framedata", frame, "QuestGroupTemplate")
	frame.data.expandedHeight = 50
	frame.data:Show()
	frame.data.quests = {}
	frame.data.fonts = {}

-------------------------------------------------------------------------
--------------------------------Lua-Tools--------------------------------
-------------------------------------------------------------------------
--replaces #list for dictionaries
local function SizeOf(list)
	local number = 0
	
	for k,v in pairs(list) do
		number=number+1
	end
	
	return number
end

--replaces #list for dictionaries, but only count the entries with numeric key
local function NumSizeOf(list)
	local number = 0
	
	for k,v in pairs(list) do
		if type(k)=="number" then
			number=number+1
		end
	end
	
	return number
end

-------------------------------------------------------------------------
-----------------------------Addon-functions-----------------------------
-------------------------------------------------------------------------
--adds a User to one of the lists
local function AddUser(name, list, value)
	if(WHUT_DEBUG["Listen"]) then DEFAULT_CHAT_FRAME:AddMessage("füge hinzu in Liste "..list..": "..name) end
	if (list==nil or name==nil) then return end
	if not value then value = 0 end
		
	if ((WHUT_user[list][name]==nil) or (value~=0)) then
		WHUT_user[list][name]=value
	end
end

--removes a User from one of the lists
local function RemoveUser(name, list)
	if(WHUT_DEBUG["Listen"]) then DEFAULT_CHAT_FRAME:AddMessage("entferne von Liste "..list..": "..tostring(name)) end
	WHUT_user[list][name]=nil
end


--sends all Users on the Online-List to name
local function SendOnline(name)
	local onlineList = ""
	filterOffline[name]=time()
	SendAddonMessage("WHUT", "V:"..WHUT_VERSION, "WHISPER", name)
	for onlineName,_ in pairs(WHUT_user[WHUT_ONLINE]) do
		if onlineList~="" then
			onlineList = onlineList..","..onlineName
		else
			onlineList = onlineName
		end
		if string.len(onlineList)>200 then
			SendAddonMessage("WHUT", "O:"..onlineList, "WHISPER", name)
			onlineList = ""
		end
	end
	
	if string.len(onlineList)>0 then
		SendAddonMessage("WHUT", "O:"..onlineList, "WHISPER", name)
	end
end

--sends all Users on the Server-List to name
local function SendServer(name)
	local serverList = ""
	filterOffline[name]=time()
	
	if (actAsServer) then
		serverList = playerName
	end
	
	for onlineName,_ in pairs(WHUT_user[WHUT_SERVER]) do
		if serverList=="" then
			serverList = onlineName
		else
			serverList = serverList..","..onlineName
		end
		if string.len(serverList)>200 then
			SendAddonMessage("WHUT", "S:"..serverList, "WHISPER", name)
			serverList = ""
		end
	end
	
	if string.len(serverList)>0 then
		SendAddonMessage("WHUT", "S:"..serverList, "WHISPER", name)
	end
end

local function GetNumActiveQuests(data)
	local active=0
	if (not data) then return end
	
	
	for key,value in pairs(data) do
	if type(key)=="number" then
		if (type(value)=="number") then
			--Quest aktiv?
			if WHUT_data[WHUT_QUEST][value] then
				active = active + 1
			end
		elseif (type(value)=="table") then
			--Untergruppen auflisten
			active = active + GetNumActiveQuests(value)
		end
	end
	end
	
	return active
end

local function GetQuestPossible(data, questid)
	if (not data) then return false end
	if WHUT_data[WHUT_QUEST][questid] then return true end
	
	--Gruppe voll: durchsuchen unnötig
	if(data["max"]) then
	if (GetNumActiveQuests(data)>=data["max"]) then
		return false
	end
	end
	
	possible = false
	
	for key,value in pairs(data) do
	if type(key)=="number" then
		if (type(value)=="number") then
			--Quest in dieser Gruppe?
			if (value==questid)then
				return true
			end
		elseif (type(value)=="table") then
			--Untergruppen durchsuchen
			if GetQuestPossible(value, questid)==true then
				return true
			end
		end
	end
	end
	
	--Quest nicht gefunden
	return false
end

local function GetQuestStatus(questid)
	local active = WHUT_data[WHUT_QUEST][questid]
	local possible = GetQuestPossible(D["Quests"],questid)
	local done = false
	local show = false
	local r,g,b = 1,1,1
	
	if (active)	then
		r,g,b = 0,1,0
	end if (possible==false) then
		r,g,b = 1,0,0
	--else
		--r,g,b = 1,1,1
	end
	
	local showActive = (active and SHOW["active"])
	local showNotActive = ((not possible) and SHOW["notactive"])
	local showUnknown = ((not active) and possible and SHOW["unknown"])
	local showDone = true --(done and SHOW["done"]) NYI
	local showNotDone = true --((not done) and SHOW["notdone"]) NYI
	show = (showActive or showNotActive or showUnknown) and (showDone or showNotDone)
	
	return r, g, b, show, possible, active, done
end

local function CheckValid()
	if (not WHUT_data[WHUT_QUEST]["valid"]) then
		WHUT_data[WHUT_QUEST]["valid"]=0
	end
	if (WHUT_data[WHUT_QUEST]["valid"] < time()+60) then --60 sec safety-time before real reset, to avoid sync-errors
		WHUT_data[WHUT_QUEST]={}
		WHUT_data[WHUT_QUEST]["valid"] = time()+GetQuestResetTime()
	end	
end

local function AddData(number)
	CheckValid()
	WHUT_data[WHUT_QUEST][tonumber(number)]=true
	if(WHUT_DEBUG["Data"]) then DEFAULT_CHAT_FRAME:AddMessage(number..": true") end
	WHUT_data[WHUT_QUEST]["valid"]=time()+GetQuestResetTime()
	
end

local function SendData(name)
	CheckValid()
	local questList = ""
	for questID,_ in pairs(WHUT_data[WHUT_QUEST]) do
		if (type(questID)=="number") then
			if questList~="" then
				questList = questList..","..tostring(questID)
			else
				questList = tostring(questID)
			end
			if string.len(questList)>200 then
				SendAddonMessage("WHUT", "Q:"..questList, "WHISPER", name)
				questList = ""
			end
		end
	end
	
	if string.len(questList)>0 then
		SendAddonMessage("WHUT", "Q:"..questList, "WHISPER", name)
	end
end

local function SaveData()
	if(not init) then return end
	if(not WHUT_save[GetRealmName()]) then
		WHUT_save[GetRealmName()]={}
	end
	WHUT_save[GetRealmName()][WHUT_USER]=WHUT_user[WHUT_USER]
	WHUT_save[GetRealmName()][WHUT_QUEST]=WHUT_data[WHUT_QUEST]
	WHUT_save["collapsed"]=WHUT_collapsed
	WHUT_save["show"]=SHOW
end

--tell the other servers that i am a server now and wait for their Data
local function BecomeServer()
	actAsServer=true
	serverUpdate=time()
	for k,v in pairs(WHUT_user[WHUT_SERVER]) do
		filterOffline[k]=time()
		SendAddonMessage("WHUT", "S:"..playerName, "WHISPER", k)
	end
end

--Filter-Function for Offline-Messages
local function filterOfflineMessages(self, event, msg, author,...)
	local str = _G["ERR_CHAT_PLAYER_NOT_FOUND_S"]:gsub("%%s", ".+")
	if msg:match(str) then 
		local pre,post = strsplit("+", (_G["ERR_CHAT_PLAYER_NOT_FOUND_S"]:gsub("%%s", "+")))
		local name = msg:gsub(pre, ""):gsub(post,"")
		if(filterOffline[name]) then
		  if ((filterOffline[name]+10)>time()) then
			WHUT_user[WHUT_ONLINE][name]=nil
			WHUT_user[WHUT_SERVER][name]=nil
			return true
		  end
		end
	end
end

-------------------------------------------------------------------------
------------------------------GUI-functions------------------------------
-------------------------------------------------------------------------
function WHUT_frame:ReAnchor()
	WHUT_frame:ClearAllPoints();
	WHUT_frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",WHUT_frame:GetLeft(),WHUT_frame:GetBottom()+WHUT_frame:GetHeight());
end

local function UpdateUserList()
	if(WHUT_DEBUG["GUI"]) then DEFAULT_CHAT_FRAME:AddMessage("Updating GUI") end
	local lastFont
	local height = 0
	local width = 0
	
	--alte Liste unsichtbar machen
	for k,v in pairs(frame.clients.names) do
		frame.clients.names[k]:SetPoint("TOPLEFT",frame.clients,"TOPLEFT")
		frame.clients.names[k]:Hide()
	end
	
	--Eigene Rolle
	if(type(frame.clients.fonts["myRole"])~="table") then
		if(WHUT_DEBUG["GUI"]) then DEFAULT_CHAT_FRAME:AddMessage("Create Server String") end
		frame.clients.fonts["myRole"] = frame.clients:CreateFontString("actAsServer")
		frame.clients.fonts["myRole"]:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE, MONOCHROME")
	end	
	if (actAsServer == true) then
		frame.clients.fonts["myRole"]:SetText(string.format(L["I'm a %s"],"|cFFFF0000"..L["SERVER"]))
	elseif (actAsServer == false) then
		frame.clients.fonts["myRole"]:SetText(string.format(L["I'm a %s"],"|cFF00FF00"..L["Client"]))
	end
	frame.clients.fonts["myRole"]:SetPoint("TOPLEFT",frame.clients,"TOPLEFT")
	height = height + frame.clients.fonts["myRole"]:GetHeight()
	width = math.max(width,frame.clients.fonts["myRole"]:GetWidth())
	lastFont = frame.clients.fonts["myRole"]
	
	--Überschrift Serverliste
	if(type(frame.clients.fonts["Server"])~="table") then
		if(WHUT_DEBUG["GUI"]) then DEFAULT_CHAT_FRAME:AddMessage("Create Server_Heading String") end
		frame.clients.fonts["Server"] = frame.clients:CreateFontString("ServerHeading")
		frame.clients.fonts["Server"]:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE, MONOCHROME")
		frame.clients.fonts["Server"]:SetText(L["Serverlist:"])
	end	
	frame.clients.fonts["Server"]:SetPoint("TOPLEFT",lastFont,"BOTTOMLEFT")
	height = height + frame.clients.fonts["Server"]:GetHeight()
	width = math.max(width,frame.clients.fonts["Server"]:GetWidth())
	lastFont = frame.clients.fonts["Server"]
	
	
	--ServerListe
	for k,v in pairs(WHUT_user[WHUT_SERVER]) do
		if(type(frame.clients.names[k])~="table") then
			if(WHUT_DEBUG["GUI"]) then DEFAULT_CHAT_FRAME:AddMessage("Create "..k.." String") end
			frame.clients.names[k]=frame.clients:CreateFontString(k)
			frame.clients.names[k]:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE, MONOCHROME")
			frame.clients.names[k]:SetText(k)
		end
		if (WHUT_user[WHUT_ONLINE][k]~=0) then
			frame.clients.names[k]:SetText(string.format("%s (%03d)",k,WHUT_user[WHUT_ONLINE][k]))
		end
		frame.clients.names[k]:SetTextColor(1,0,0)
		frame.clients.names[k]:SetPoint("TOPLEFT",lastFont,"BOTTOMLEFT")
		frame.clients.names[k]:Show()
		height = height + frame.clients.names[k]:GetHeight()
		width = math.max(width,frame.clients.names[k]:GetWidth())
		lastFont = frame.clients.names[k]
	end
	
	if(actAsServer) then
		--Überschrift Onlineliste
		if(type(frame.clients.fonts["Online"])~="table") then
			if(WHUT_DEBUG["GUI"]) then DEFAULT_CHAT_FRAME:AddMessage("Create Client_Heading String") end
			frame.clients.fonts["Online"] = frame.clients:CreateFontString("OnlineHeading")
			frame.clients.fonts["Online"]:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE, MONOCHROME")
			frame.clients.fonts["Online"]:SetText(L["Clientlist:"])
		end	
		frame.clients.fonts["Online"]:SetPoint("TOPLEFT",lastFont,"BOTTOMLEFT")
		height = height + frame.clients.fonts["Online"]:GetHeight()
		width = math.max(width,frame.clients.fonts["Online"]:GetWidth())
		lastFont = frame.clients.fonts["Online"]
		
	
		--OnlineListe
		for k,v in pairs(WHUT_user[WHUT_ONLINE]) do
		if(not WHUT_user[WHUT_SERVER][k]) then
			if(type(frame.clients.names[k])~="table") then
				if(WHUT_DEBUG["GUI"]) then DEFAULT_CHAT_FRAME:AddMessage("Create "..k.." String") end
				frame.clients.names[k]=frame.clients:CreateFontString(k)
				frame.clients.names[k]:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE, MONOCHROME")
				frame.clients.names[k]:SetText(k)
			end
			if (WHUT_user[WHUT_ONLINE][k]~=0) then
				frame.clients.names[k]:SetText(string.format("%s (%03d)",k,WHUT_user[WHUT_ONLINE][k]))
			end
			frame.clients.names[k]:SetTextColor(0,1,0)
			frame.clients.names[k]:SetPoint("TOPLEFT",lastFont,"BOTTOMLEFT")
			frame.clients.names[k]:Show()
			height = height + frame.clients.names[k]:GetHeight()
			width = math.max(width,frame.clients.names[k]:GetWidth())
			lastFont = frame.clients.names[k]
		end
		end
	end
	
	frame.clients:SetHeight(height)
	frame.clients:SetWidth(width)
end

local function CollapseQuestGroup(groupframe)
	WHUT_collapsed[tostring(groupframe:GetName())] = true;
	groupframe.CollapsedIcon:Show();
	groupframe.ExpandedIcon:Hide();
	groupframe.Content:Hide()
	groupframe:SetHeight(18);
	groupframe.BgMinimized:Show();
	groupframe.BgTop:Hide();
	groupframe.BgMiddle:Hide();
	groupframe.BgBottom:Hide();
end

local function ExpandQuestGroup(groupframe)
	WHUT_collapsed[tostring(groupframe:GetName())] = false;
	groupframe.CollapsedIcon:Hide();
	groupframe.ExpandedIcon:Show();
	groupframe.Content:Show()
	groupframe:SetHeight(22+groupframe.Content:GetHeight())
	groupframe.BgMinimized:Hide();
	groupframe.BgTop:Show();
	groupframe.BgMiddle:Show();
	groupframe.BgBottom:Show();
end


--[[
H: Header
Q: Quest
F: Frame (i.e. the subgroup under a Header)
h: horizontal
v: vertical
]]--
local SPACE = {
	["H"]={
		["h"]=0,
		["v"]=0
		},
	["Q"]={
		["h"]=5,
		["v"]=0
		},
	["F"]={
		["h"]=10,
		["v"]=0
		},
	}
local function UpdateData(data, parent)	
	local i=1
	if (not data) then return end
	--parent.Content:SetWidth(0)
	parent.Content:SetHeight(0)
	local lastFrame, lastPoint = parent.Content, "TOP"
	
	
	for key,value in pairs(data) do
	if type(key)=="number" then
		if (type(value)=="number") then
			--Quest darstellen
			local v=value
			local r,g,b,show,active,possible,done = GetQuestStatus(v)
			
				if(type(parent[i])~="table") then
					parent[i] = parent.Content:CreateFontString()
					parent[i]:SetFont(WHUT_FONT, WHUT_FONTSIZE, WHUT_FONTFLAG)
				end
			
				--Questnamen aus Tooltip holen
				if ((not Q[v]) or (Q[v]==tostring(v))) then
					GameTooltip:SetOwner(_G.UIParent, _G.ANCHOR_NONE)
					GameTooltip:SetHyperlink(("quest:%d"):format(v))
					local quest_name = _G["GameTooltipTextLeft1"]:GetText()
					GameTooltip:Hide()
					--DEFAULT_CHAT_FRAME:AddMessage(v..": "..tostring(quest_name))
					if quest_name then
						Q[v]=quest_name
					else
						Q[v]=string.format(L["Quest #%s does not exist"], v)
					end
				end
				
			if show then
				parent[i]:SetText(Q[v])
				parent[i]:SetTextColor(r,g,b)
			
				parent[i]:ClearAllPoints()
				parent[i]:SetPoint("TOP", lastFrame, lastPoint,0,-SPACE.Q.v)
				lastFrame, lastPoint = parent[i],"BOTTOM"
			
				parent[i]:SetPoint("LEFT", parent.Content, "LEFT", SPACE.Q.h,0)
				parent.Content:SetWidth(math.max(parent.Content:GetWidth(),parent[i]:GetWidth()+SPACE.Q.h))
				parent.Content:SetHeight(parent.Content:GetHeight()+parent[i]:GetHeight()+SPACE.Q.v)
				parent[i]:Show()
			else
				parent[i]:Hide()
			end
			
			i = i + 1
			
		elseif (type(value)=="table") then repeat
		
				if (value["faction"] and value["faction"]~=playerFaction) then
						break
				end
				
				--Frame erzeugen
				if(type(parent[i])~="table") then
					parent[i] = CreateFrame("Frame",parent:GetName().."-"..i,parent.Content,"QuestGroupTemplate")
					--WHUT_collapsed[tostring(parent[i]:GetName())]=true
				end
				
				parent[i]:ClearAllPoints()

				local head = ""
				if(value["name"]) then
					head=value["name"]
				end
				if(value["max"])then
					head = head.." - ("
					local active = GetNumActiveQuests(value)
					if active~=0 then
						head=head..active.."/"
					end
					head=head..value["max"]..")"
				end
				
				parent[i].NameText:SetText(head)
				parent[i].Content:SetWidth(parent[i].NameText:GetWidth()+parent[i].CollapsedIcon:GetWidth()+10)
				parent[i].Content:SetHeight(0)
				
				
				
				parent[i]:SetPoint("TOP", lastFrame, lastPoint,0,-SPACE.Q.v)
				lastFrame, lastPoint = parent[i],"BOTTOM"
				parent[i]:SetPoint("LEFT", parent.Content, "LEFT", SPACE.F.h,0)
				
				--Untergruppen auflisten
				UpdateData(value,parent[i])
				
				
				if (WHUT_collapsed[tostring(parent[i]:GetName())]) then
					CollapseQuestGroup(parent[i])
				else
					ExpandQuestGroup(parent[i])
				end
				
				parent.Content:SetWidth(math.max(parent.Content:GetWidth(),parent[i]:GetWidth()+SPACE.F.h))
				parent.Content:SetHeight(parent.Content:GetHeight()+parent[i]:GetHeight()+SPACE.F.v)
				
				parent[i].BgTop:SetSize(parent[i].Content:GetWidth(),9)
				parent[i].BgMiddle:SetWidth(parent[i].Content:GetWidth())
				parent[i].BgBottom:SetSize(parent[i].Content:GetWidth(),9)
				parent[i].BgMinimized:SetWidth(parent[i].Content:GetWidth())
				i = i + 1
			until true end
		end
	end
	
	parent:SetWidth(parent.Content:GetWidth())
	if (WHUT_collapsed[tostring(parent:GetName())]==true) then
		parent:SetHeight(18)
	else
		parent:SetHeight(22+parent.Content:GetHeight())
	end
end

local function clearAnchors(frame)
	for k,v in ipairs(frame) do
		clearAnchors(v)
	end
	frame:ClearAllPoints()
end

function WHUT_UpdateGui()
	--[[
	if (not frame.clients:IsShown() and not frame.data:IsShown() and not frame.optionsFrame:IsShown()) then
		frame:Hide()
		return
	end
	]]
	
	local lastFrame, lastPoint, dx, dy = frame.buttonFrame, "BOTTOMLEFT", 10, -10
		
	local contentHeight, contentWidth = 0,0
	local optionsHeight, optionsWidth = 0,0	
	
	if (frame.optionsFrame:IsShown())then
		frame.optionsFrame:ClearAllPoints()
		frame.optionsFrame:SetPoint("TOPLEFT",lastFrame, lastPoint, dx, dy)
		optionsHeight = frame.optionsFrame:GetHeight() + 10
		contentWidth = frame.optionsFrame:GetWidth() + 10
		lastFrame, lastPoint, dx, dy = frame.optionsFrame, "BOTTOMLEFT", 0, -10
	end
	if (frame.clients:IsShown()) then
		UpdateUserList()
		frame.clients:SetPoint("TOPLEFT",lastFrame, lastPoint, dx, dy)
		contentHeight = frame.clients:GetHeight()
		contentWidth = contentWidth + frame.clients:GetWidth() + 10
		lastFrame, lastPoint, dx, dy = frame.clients, "TOPRIGHT", 10, 0
	end
	if (frame.data:IsShown()) then
		clearAnchors(frame.data)
		UpdateData(D["Quests"],frame.data)
		--Grafik auf richtige Größe
		frame.data.NameText:SetText("Quests")
		frame.data.BgTop:SetSize(frame.data.Content:GetWidth(),9)
		frame.data.BgMiddle:SetWidth(frame.data.Content:GetWidth())
		frame.data.BgBottom:SetSize(frame.data.Content:GetWidth(),9)
		frame.data.BgMinimized:SetWidth(frame.data.Content:GetWidth())
		--Dimensionen für frame bestimmen
		contentHeight = math.max(contentHeight, frame.data:GetHeight())
		contentWidth = contentWidth + frame.data:GetWidth() + 10
		frame.data:SetPoint("TOPLEFT",lastFrame, lastPoint, dx, dy)
	end
	
	
	frame:SetWidth(math.max(frame.buttonFrame:GetWidth()+10,optionsWidth,contentWidth)+10)
	frame:SetHeight(frame.buttonFrame:GetHeight()+optionsHeight+contentHeight+20)
end
-------------------------------------------------------------------------
-----------------------------Event-functions-----------------------------
-------------------------------------------------------------------------

SLASH_WHUT1 = "/whatsuptoday"
SLASH_WHUT2 = "/whut"
SlashCmdList["WHUT"] = function(cmd) 
	if(not cmd or string.len(cmd)==0) then
		--Slashkommande ohne Optionen
		DEFAULT_CHAT_FRAME:AddMessage("WhatsUpToday-Slashkommandos:")
		DEFAULT_CHAT_FRAME:AddMessage("/whut showuser/hideuser - Blendet die Nutzerliste ein/aus")
		DEFAULT_CHAT_FRAME:AddMessage("/whut showdata/hidedata - Blendet die Questliste ein/aus")
		DEFAULT_CHAT_FRAME:AddMessage("/whut update - Aktualisiert die Daten")
		DEFAULT_CHAT_FRAME:AddMessage("/whut add <online/server/user> Name - Fügt einen Nutzer einer Liste hinzu")
		DEFAULT_CHAT_FRAME:AddMessage("/whut list <online/server/user> Name- Zeigt eine Liste an")
		DEFAULT_CHAT_FRAME:AddMessage("/whut remove <online/server/user> Name- Entfernt einen Nutzer von einer Liste")
		DEFAULT_CHAT_FRAME:AddMessage("/whut request <online/server> Name- Fragt einen Nutzer nach seiner Liste")
		DEFAULT_CHAT_FRAME:AddMessage("/whut update - Fragt alle Nutzer nach allen Listen")
		DEFAULT_CHAT_FRAME:AddMessage("/whut addquest #### - Setzt eine Quest als verfügbar")
	else
	--Optionen
	
		local split1, split2, cmd = strsplit(" ",cmd,3)
		--online/server/users
		local list = "";
		if (split2=="online") then
			list = WHUT_ONLINE
		elseif (split2=="server") then
			list = WHUT_SERVER
		elseif (split2=="user") then
			list = WHUT_USER
		end
		
		--add/list/remove
		if(split1 == "add") then
			AddUser(tostring(cmd), list)
		elseif(split1 == "list") then
			for k,v in pairs(WHUT_user[list]) do
				DEFAULT_CHAT_FRAME:AddMessage("Online: "..tostring(k)..tostring(v))
			end
		elseif(split1 == "remove") then
			RemoveUser(tostring(cmd),list)
		elseif(split1 == "request") then
			DEFAULT_CHAT_FRAME:AddMessage("Request "..list.."-List from "..cmd)
			if (list=="online") then
				filterOffline[cmd]=time()
				SendAddonMessage("WHUT", "R:O", "WHISPER", cmd)
			elseif (list=="server") then
				filterOffline[cmd]=time()
				SendAddonMessage("WHUT", "R:S", "WHISPER", cmd)
			end
		elseif(split1 == "update") then
			SendAddonMessage("WHUT", "R:S,O,D", "GUILD")
			SendAddonMessage("WHUT", "R:S,O,D", "RAID")
			for k,v in pairs(WHUT_user[WHUT_SERVER]) do
				filterOffline[k]=time()
				SendAddonMessage("WHUT", "R:S,O,D", "WHISPER", k)
			end
		elseif(split1 == "showuser") then
			frame:Show()
			frame.clients:Show()
			WHUT_UpdateGui()
		elseif(split1 == "showdata") then
			frame:Show()
			frame.data:Show()
			WHUT_UpdateGui()
		elseif(split1 == "hideuser") then
			frame.clients:Hide()
			WHUT_UpdateGui()
		elseif(split1 == "hidedata") then
			frame.data:Hide()
			WHUT_UpdateGui()
		elseif(split1 == "addquest") then
			AddData(split2)
		end
		
	end
end

local function WHUT_OnEvent(self,event,...)
	if(event=="CHAT_MSG_ADDON") then
		--Handle Addon Messages
		--Messages:
		--"R:X" - requesting:
		--"S" - server list
		--"O" - requesting online list
		--"D" - requesting data
		--"C" - requesting Online-Check (to be responded with "V:####")
		--"UL" - User leaving
		--"V:####" - User-Version (this is the way to tell others that im online)
		--"S:Name" - Name is a Server
		--"O:Name" - Name is online
		--"Q:####" - Quest with Number is active today
		--"N:####" - NPC with Number is active today (NYI)
		--"H:####" - Hash to Check Data-Sync (NYI)

		local prefix, message, channel, sender = ...;
		
		if (prefix~="WHUT") then return end
		
		if (WHUT_DEBUG["Chat"]) then
			DEFAULT_CHAT_FRAME:AddMessage(channel.."||"..sender.."||"..message)
		--[[
			DEFAULT_CHAT_FRAME:AddMessage("Addon-Message erhalten!")
			DEFAULT_CHAT_FRAME:AddMessage("prefix: "..prefix)
			DEFAULT_CHAT_FRAME:AddMessage("message: "..message)
			DEFAULT_CHAT_FRAME:AddMessage("channel: "..channel)
			DEFAULT_CHAT_FRAME:AddMessage("sender: "..sender)
			]]
		end
		
		local senderName, senderRealm = strsplit("-",sender,2)
		
		
		if senderRealm then
			WHUT_save[senderRealm][WHUT_USER][senderName]=true
			if WHUT_DEBUG["Chat"] then DEFAULT_CHAT_FRAME:AddMessage("Cross-Realm-Spieler gefunden: "..senderName.." von "..senderRealm) end
		end
		
		local cmd = strsub(message,1,2)
		local arg = strsub(message,3)
		
		if(WHUT_user[WHUT_SERVER][sender]) then
			WHUT_user[WHUT_SERVER][sender]=time()
		end
		
		if (sender==playerName) then
			return
		end
		
		AddUser(sender, WHUT_ONLINE)
		AddUser(sender, WHUT_USER)
		
		if (cmd=="R:") then
			while (arg) do
				request,arg = strsplit(",",arg,2)
				if (request=="S") then
					SendServer(sender)
				elseif (request=="O") then
					SendOnline(sender)
				elseif (request=="D") then
					SendData(sender)
				elseif (request=="C") then
					filterOffline[sender]=time()
					SendAddonMessage("WHUT", "V:"..WHUT_VERSION, "WHISPER", sender)
				end
			end
		elseif (cmd=="UL") then
			RemoveUser(sender,WHUT_SERVER)	
			RemoveUser(sender,WHUT_ONLINE)
		elseif (cmd=="V:") then
			AddUser(sender,WHUT_ONLINE,tonumber(arg))
			AddUser(sender,WHUT_USER,time())
			if ((WHUT_VERSION~=0) and (newVersionHint==false) and (tonumber(arg)>WHUT_VERSION)) then
				DEFAULT_CHAT_FRAME:AddMessage(string.format(L["A new version is available. Download it at %s"],"http://www.curse.com/addons/wow/whats-today"))
				newVersionHint=true
			elseif ((WHUT_VERSION~=0) and (tonumber(arg)<WHUT_VERSION)) then
				filterOffline[sender]=time()
				SendAddonMessage("WHUT", "V:"..WHUT_VERSION, "WHISPER", sender)
			end
		elseif (cmd=="S:") then
			while (arg) do
				serverName,arg = strsplit(",",arg,2)
				if (serverName==playerName and actAsServer==false) then
					--i am server now
					BecomeServer()
				elseif (serverName~=playerName and not WHUT_user[WHUT_SERVER][serverName]) then
					--i know a new server - i assume he is online and a user
					
					--tell the server name to the known servers
					for k,v in pairs(WHUT_user[WHUT_SERVER]) do
						filterOffline[k]=time()
						SendAddonMessage("WHUT", "S:"..serverName, "WHISPER", k)
					end
					--add him to all lists
					AddUser(serverName,WHUT_SERVER)
					AddUser(serverName,WHUT_ONLINE)
					AddUser(serverName,WHUT_USER)
					
					--tell him about me
					if (actAsServer) then
						filterOffline[serverName]=time()
						SendAddonMessage("WHUT", "S:"..playerName, "WHISPER", serverName)
						SendOnline(serverName)
						SendServer(serverName)
						SendData(serverName)
					else
						filterOffline[serverName]=time()
						SendAddonMessage("WHUT", "O:"..playerName, "WHISPER", serverName)
					end
				end
			end
		elseif (cmd=="O:") then
			while (arg) do
				name,arg = strsplit(",",arg,2)
				if (name~=playerName) then
					AddUser(name,WHUT_ONLINE)
					AddUser(name,WHUT_USER)
				end
			end
		elseif (cmd=="Q:") then
			while (arg) do
				questID,arg = strsplit(",",arg,2)
				AddData(questID)
			end
		end
	elseif(event=="GROUP_ROSTER_UPDATE") then 
		raidUpdate=time()
	elseif(event=="PLAYER_ENTERING_WORLD") then
		SaveData()
		onlineSince=time()
	elseif(event=="PLAYER_LEAVING_WORLD") then
		SaveData()
		if (actAsServer==true) then
			for k,v in pairs(WHUT_user[WHUT_ONLINE]) do
				filterOffline[k]=time()
				SendAddonMessage("WHUT", "UL", "WHISPER", k)
			end
		end
	elseif(event=="VARIABLES_LOADED") then
		--frame:ClearAllPoints();
		--frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",frame:GetLeft(),frame:GetBottom()+frame:GetHeight())
			
		if(not WHUT_save[GetRealmName()]) then
			WHUT_save[GetRealmName()]={}
		end
		if(type(WHUT_save[GetRealmName()][WHUT_USER]) ~= "table") then
			WHUT_save[GetRealmName()][WHUT_USER]={}
		end
		if(type(WHUT_save[GetRealmName()][WHUT_QUEST]) ~= "table") then
			WHUT_save[GetRealmName()][WHUT_QUEST]={}
		end
		if (type(WHUT_save["collapsed"]) ~= "table") then
			WHUT_save["collapsed"]={}
		end
		if (type(WHUT_save["show"]) ~= "table") then
			WHUT_save["show"]={}
		end
		
		WHUT_user[WHUT_USER]=WHUT_save[GetRealmName()][WHUT_USER]
		WHUT_data[WHUT_QUEST]=WHUT_save[GetRealmName()][WHUT_QUEST]
		WHUT_collapsed=WHUT_save["collapsed"]
		SHOW=WHUT_save["show"]		
		WHUT_CheckAvailable:SetChecked(SHOW["active"])
		WHUT_CheckNotAvailable:SetChecked(SHOW["notactive"])
		WHUT_CheckUnknown:SetChecked(SHOW["unknown"])
		
	elseif(event=="QUEST_ACCEPTED") then
		local questTitle, _,_,_,_,_,_,isDaily,questID = GetQuestLogTitle(...)
		DEFAULT_CHAT_FRAME:AddMessage("QuestAccepted: "..questID)
		--if(isDaily) then
			AddData(questID)
			for k,v in pairs(WHUT_user[WHUT_SERVER]) do
				SendAddonMessage("WHUT", "Q:"..questID, "WHISPER", k)
			end
		--end
	elseif(event=="GOSSIP_SHOW") then
		--DEFAULT_CHAT_FRAME:AddMessage("QuestGreeting")
		for i=1,GetNumGossipAvailableQuests(),1 do
			local title,_,_,isDaily = select((i-1)*6+1,GetGossipAvailableQuests())
			for qID,qTitle in pairs(Q) do
				if (qTitle==title) then
					AddData(qID)
					for k,v in pairs(WHUT_user[WHUT_SERVER]) do
						SendAddonMessage("WHUT", "Q:"..qID, "WHISPER", k)
					end
				end
			end
		end
	elseif(event=="QUEST_DETAIL") then
		--DEFAULT_CHAT_FRAME:AddMessage("QuestDetail")
		local title = GetTitleText()
		--DEFAULT_CHAT_FRAME:AddMessage(title..": "..tostring(isDaily))
		for qID,qTitle in pairs(Q) do
			if (qTitle==title) then
				AddData(qID)
				for k,v in pairs(WHUT_user[WHUT_SERVER]) do
					SendAddonMessage("WHUT", "Q:"..qID, "WHISPER", k)
				end
			end
		end
	end
end

local function WHUT_OnUpdate(self, elapsed)
timeSinceLastUpdate = timeSinceLastUpdate + elapsed; 	
timeSinceLastSync = timeSinceLastSync + elapsed; 

--short time
if (timeSinceLastUpdate > WHUT_UpdateInterval) then
 
	--wait 10 sec after a Raid/Group-Update, then ask for Serverlist
	if (raidUpdate>0 and raidUpdate+10<time()) then
		if(WHUT_DEBUG["Roster"]) then DEFAULT_CHAT_FRAME:AddMessage("unbehandelte Gruppenänderung vor mehr als 10 Sekunden - Frage Serverliste ab") end
		SendAddonMessage("WHUT", "R:S", "RAID")
		raidUpdate=0
	end

	--wait 30 sec after becoming a server for other servers to share Data/Lists, then tell everyone you are server
	if (serverUpdate>0 and serverUpdate+30<time()) then
		if(WHUT_DEBUG["Roster"]) then DEFAULT_CHAT_FRAME:AddMessage("wurde zum Server vor mehr als 30 Sekunden - gebe bekannt!") end
		for k,v in pairs(WHUT_user[WHUT_ONLINE]) do
			filterOffline[k]=time()
			SendAddonMessage("WHUT", "S:"..playerName, "WHISPER", k)
		end
		serverUpdate=0
	end
	
	--try to get a Server-List, 10 sec after going online
	if (time()>onlineSince+10 and init==false) then
		SendAddonMessage("WHUT", "R:S", "GUILD")
		for k,v in pairs(WHUT_user[WHUT_USER]) do
			filterOffline[k]=time()
			--DEFAULT_CHAT_FRAME:AddMessage("Send Initial Whisper to "..k)
			SendAddonMessage("WHUT", "R:S", "WHISPER", k)
		end
		init=true
	end
	
	--wait 60 sec after going online, if no server found then, become one
	if (onlineSince>0 and onlineSince+60<time()) then
		if (SizeOf(WHUT_user[WHUT_SERVER])==0 and actAsServer==false) then
			if(WHUT_DEBUG["Roster"]) then DEFAULT_CHAT_FRAME:AddMessage("60 sec online und "..SizeOf(WHUT_user[WHUT_SERVER]).." Server bekannt - dann mach ichs selbst") end
			BecomeServer()
		end
		--onlineSince=0
	end
	
	--to few serves
	if (SizeOf(WHUT_user[WHUT_SERVER])<numberOfServers and actAsServer==true) then
		for k,v in pairs(WHUT_user[WHUT_ONLINE]) do
			if (not WHUT_user[WHUT_SERVER][k]) then
				filterOffline[k]=time()
				AddUser(k, WHUT_SERVER)
				SendServer(k)
				SendOnline(k)
				SendData(k)
				SendAddonMessage("WHUT", "S:"..k, "WHISPER", k)
				break
			end
		end
	end
	
	CheckValid()
	if  (WHUT_collapsed[tostring(frame.data:GetName())]) then
		CollapseQuestGroup(frame.data)
	else
		ExpandQuestGroup(frame.data)
	end
	WHUT_UpdateGui()
	
    timeSinceLastUpdate = 0;
end
  
--long time
if (timeSinceLastSync > WHUT_SyncInterval) then
	if(actAsServer) then
		--Synchronize Lists
		for k,v in pairs(WHUT_user[WHUT_SERVER]) do
			filterOffline[k]=time()
			SendAddonMessage("WHUT", "R:S,O,D", "WHISPER", k)
		end
	
		--Update online users
		for name,_ in pairs(WHUT_user[WHUT_ONLINE]) do
			if not WHUT_user[WHUT_SERVER][name] then
				WHUT_user[WHUT_ONLINE][name]=nil
				SendAddonMessage("WHUT", "R:C", "WHISPER", name)
			end
		end
	else 
		--Update only from one Server
		for k,v in pairs(WHUT_user[WHUT_SERVER]) do
			filterOffline[k]=time()
			SendAddonMessage("WHUT", "R:S,D", "WHISPER", k)
			break
		end
	end
	timeSinceLastSync = 0
end
  
end

frame:SetScript("OnEvent", WHUT_OnEvent)
frame:SetScript("OnUpdate", WHUT_OnUpdate)
ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", filterOfflineMessages)

